=== AspectC++/examples/threads/Makefile ===
LDFLAGS=-lpthread
include ../Makefile.generic
