=== AspectC++/tests/SimpleGetAdvice/Makefile ===
ACFLAGS ?= --builtin_operators --data_joinpoints
include ../Makefile.generic
