=== Puma/tests/bug259/Makefile ===
include ../Makefile.generic
