=== Puma/tools/lemon/Makefile ===
all: lemon

lemon: lemon.c

clean:
	rm -f lemon *~
