=== debian/changelog ===
aspectc++ (1:2.3-4) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Feb 2021 09:49:38 -0500

aspectc++ (1:2.3-3) experimental; urgency=medium

  * Re-enable the float128 patch

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Feb 2021 14:34:04 -0500

aspectc++ (1:2.3-2) experimental; urgency=medium

  * Add patch from upstream that fixes 32bit segfault
  * Disable clang-gcc14-workaround and float128 patches

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Feb 2021 08:32:46 -0500

aspectc++ (1:2.3-1) unstable; urgency=medium

  * New upstream version 2.3
    - only cleanups and important Clang 11 related fixes compared to
      previous snapshot
  * drop pkgconfig.patch, merged upstream

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Feb 2021 20:10:30 -0500
