=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
 	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
           VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772 \
-          Bug781 Bug784
+          Bug781 Bug784 BugUsingAttribute
 
 ifeq ($(FRONTEND),Clang)
 ACTESTS += DataFlowAnalysis
@@ -41,7 +41,7 @@
            ArrayAccessAdvice MatchScope GetBaseDerived \
            Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
            Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef Float128Basic \
-           EntityInfo VolatileResult
+           EntityInfo VolatileResult Bug792 BugAttribInConstexpr StdCxx17
 ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
 		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
 		   #Attribute_paramsIntrospection Attribute_stringParam
