=== AspectC++/tests/ArrayAccessAdvice/Makefile ===
ACFLAGS += --builtin_operators --data_joinpoints
CXXFLAGS += -std=gnu++11
include ../Makefile.generic
