=== AspectC++/tests/Instantiation/Makefile ===
ACFLAGS ?= -v9
include ../Makefile.generic
