=== debian/changelog ===
aspectc++ (1:2.3+git20221129-1) unstable; urgency=medium

  * New upstream version
  * Build against llvm-14, closes: #1012184, #1004884, #1012897

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 29 Nov 2022 17:54:11 -0500

aspectc++ (1:2.3+git20211104-2) unstable; urgency=medium

  * Update float128.patch, kudost oFrédéric Bonnard <frediz@debian.org>
    for the patch!

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 22 Nov 2021 15:49:20 -0500

aspectc++ (1:2.3+git20211104-1) unstable; urgency=medium

  * New upstream version
  * Compile against clang-12, Closes: #997111

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 04 Nov 2021 11:30:14 -0400
