=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Reinhard Tartler <siretart@tauware.de>
-Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-11-dev, libclang-11-dev
+Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-14-dev, libclang-14-dev
 Build-Depends-Indep: doxygen, graphviz, gsfonts
 Standards-Version: 4.4.1
 Homepage: http://www.aspectc.org
